#!/usr/local/bin/python

########################################################################
# web2ldap
# (c) by Michael Stroeder <michael@stroeder.com>
# Distributed under GNU Public License (GPL)
# web-based LDAP Client, see http://www.web2ldap.de for details
########################################################################

import sys,os

if os.environ.has_key('GATEWAY_INTERFACE'):

  if os.name == 'posix':
    # For finding web2ldapcnf.py in /usr/local/web2ldap/etc/web2ldap on FreeBSD systems
    sys.path.append('/usr/local/web2ldap/etc/web2ldap')
  else:
    # For finding web2ldapcnf.py in system dirs on Windows systems
    for i in ['SystemRoot','windir']:
      if os.environ.has_key(i):
	sys.path.append(os.environ[i])

  import web2ldapcnf
  sys.path.extend(web2ldapcnf.pylibdirs)

  ########################################################################
  # Script was invoked trough CGI-BIN interface of web server
  ########################################################################

  import w2lhandler
  w2lhandler.HandleHTTPRequest(sys.stdin,sys.stdout,os.environ)
  sys.exit(0)

else:

  ######################################################################
  # The script was invoked directly => start persistent HTTP handler
  ######################################################################

  sys.stderr.write("""***Error:
This execuctable has to be run under the contol of a web server
through common gateway interface (CGI).

Use sbin/web2ldap.py instead for running web2ldap as stand-alone
web gateway demon.
""")
  sys.exit(1)
