import string


def Addr2Int(AddrStr):
  try:
    AddrList = string.split(AddrStr,'.',3)
  except ValueError:
    raise ValueError,"IP address must have numerical form, e.g. 123.234.45.67"
  AddrInt = int(AddrList[0])
  for i in AddrList[1:]:
    AddrInt = AddrInt<<8|int(i)
  return AddrInt


# IP-Adresse in Stringform zu 2er-Integer-Tupel (addr,mask) konvertieren
def AddrMask_Str2Tuple(AddrMaskStr):
  try:
    AddrStr, MaskStr = string.split(AddrMaskStr,'/',1)
  except ValueError:
    raise ValueError,"Argument must have the form [ip address]/[netmask]"
  return (Addr2Int(AddrStr),Addr2Int(MaskStr))


# IP-Adresse mit Netzwerkadresse/Netzwerkmaske vergleichen
def MatchIPAddr(AddrStr,NetAddrMaskTuple):
  AddrInt = Addr2Int(AddrStr)
  NetAddr,NetMask = NetAddrMaskTuple
  return (NetAddr & NetMask) == (AddrInt & NetMask)


# return 1 (true) if any (Addr,Mask) in AddrMaskTupleList is matched
# by IP address given in AddrStr
# return 0 (false) if none matches
def MatchIPAdrList(AddrStr,AddrMaskTupleList):
  i=0 ; ListLen = len(AddrMaskTupleList)
  while i<ListLen and not MatchIPAddr(AddrStr,AddrMaskTupleList[i]):
    i=i+1
  return i<ListLen

