##############################################################################
# msbase.py Version 0.1.3
# (c) by Michael Stroeder <michael@stroeder.com>
##############################################################################
# This module is distributed under the terms of the
# GPL (GNU GENERAL PUBLIC LICENSE) Version 2
# (see http://www.gnu.org/copyleft/gpl.html)
##############################################################################

import sys, string, UserDict


# Alle Vorkommen aller Elemente von removelist in l loeschen
# Kein Fehler, falls ein Element aus removelist nicht in l enthalten ist.
def listremove(l,removelist,ignorecase=0):
  if ignorecase:
    searchlist = map(string.lower,l)
    removelist = map(string.lower,removelist)
  else:
    searchlist = l
  indexlist = []
  for i in range(len(searchlist)):
    if searchlist[i] in removelist:
      indexlist.append(i)
  indexlist.reverse()
  for i in indexlist:
    del l[i]
  return
    
# Schnelle Schnittmenge
def intersection(a,b):
  temp = {}
  result = []
  for elt in a:
    temp[elt] = 1
  for elt in b:
    if temp.has_key(elt):
      result.append(elt)
  return result

# Schnelle Vereinigungsmenge
def union(a,b):
  temp = {}
  for elt in a:
    temp[elt] = 1
  for elt in b:
    temp[elt] = 1
  return temp.keys()


# Dictionary-Klasse, die bei nicht vorhandenem
# Key einen Default-Wert ausgibt
class DefaultDict(UserDict.UserDict):

  def __init__(self,default=''):
    self.default = default
    UserDict.UserDict.__init__(self)

  def __getitem__(self,key):
    return self.data.get(key, self.default)


# Class for grabbing the string-formatting keys out of a string
class GrabKeys:

    def __init__(self,s):
        self.keys = []
	s % self

    def __getitem__(self, name):
        self.keys.append(name)
        return 0 # 0 is apparently compatible with all % format characters


# Dictionary class for case-insensitive string-keyed dictionaries
class CaseinsensitiveStringKeyDict(UserDict.UserDict):

  def __init__(self, data = {}):
    UserDict.UserDict.__init__(self)
    if data:
      for i in data.keys():
        self.data[string.lower(i)] = data[i]

  def __setitem__(self,key,data):
    self.data[string.lower(key)] = data

  def __getitem__(self,key):
    return self.data[string.lower(key)]

  def has_key(self,key):
    return self.data.has_key(string.lower(key))

  def get(self,key,default):
    return self.data.get(string.lower(key), default)

