########################################################################
# web2ldap
# (c) by Michael Stroeder <michael@stroeder.com>
# Distributed under GNU Public License (GPL)
# web-based LDAP Client, see http://www.web2ldap.de for details
########################################################################

import sys,web2ldapcnf

# Modules shipped with web2ldap
import cgiforms, charset, w2lcore

##############################################################################
# Login form
##############################################################################

def w2l_Login(outf,command,form,ldap_session):

  ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_dn = ldap_session

  if 'login_binddn' in form.inputkeys:
    ldap_binddn = w2lcore.input2utf(form.accept_charset,form.field['login_binddn'][0].content)

  w2lcore.PrintHeader(outf,'',form.accept_charset)
  outf.write("""
<div id=inputdiv>
<form 
  action="%s/searchform"
  method="%s" 
  enctype="application/x-www-form-urlencoded"
  accept-charset="%s"
>
<h1>login</h1>
<p>
  Simply press <strong>Login</strong> for anonymous access.
</p>
<p>
  <input type=submit value="Login">
</p>
<table summary="Login form">
  <tr>
    <td>Bind as</td><td><input name="ldap_binddn" maxlength=200 size=40 value="%s"></td>
  </tr>
  <tr>
    <td>with password</td><td><input type="password" name="ldap_bindpasswd" maxlength=100 size=15 value=""></td>
  </tr>
  <tr>
    <td>to host:port</td>
    <td>
""" % (form.script_name,web2ldapcnf.script_method,form.accept_charset,w2lcore.utf2display(form.accept_charset,ldap_binddn)))

  if not 'ldap_host' in form.inputkeys:
    ldap_host = ''

  if ldap_host and (not ldap_host in web2ldapcnf.ldap_host_list):
    outf.write('<input name="ldap_host" maxlength=100 size=30 value="%s">' % (ldap_host))
  else:
    if len(web2ldapcnf.ldap_host_list)>1:
      outf.write('<select name="ldap_host" size=1>')
      for option in web2ldapcnf.ldap_host_list:
	outf.write('<option%s>%s</option>' % (' selected'*(option==ldap_host),option))
      outf.write('</select></td></tr>')
      ldap_host = ''
    else:
      if web2ldapcnf.ldap_host_list:
        ldap_host = web2ldapcnf.ldap_host_list[0]
      else:
        ldap_host = ''
      outf.write('<input name="ldap_host" maxlength=100 size=30 value="%s">' % (ldap_host))

  if ldap_host:
    if not ldap_dn:
      ldap_dn = charset.iso2utf(web2ldapcnf.ldap_def.get(ldap_host,{}).get('basedn',''))
    outf.write('<tr><td>base DN</td><td><input name="ldap_dn" maxlength=255 size=30 value="%s"></td></tr>' % (ldap_dn))

  outf.write('</table></form></div>')
  w2lcore.PrintFooter(outf)
