########################################################################
# web2ldap
# (c) by Michael Stroeder <michael@stroeder.com>
# Distributed under GNU Public License (GPL)
# web-based LDAP Client, see http://www.web2ldap.de for details
########################################################################

import sys,cgiforms,ldap,ldapbase,w2lcore,web2ldapcnf

########################################################################
# Modify RDN
########################################################################

def w2l_ModRDN(outf,command,form,ldap_session):

  ldap_host,ldap_binddn,ldap_bindpasswd,ldap_obj,ldap_defaults,ldap_dn = ldap_session

  if not ldap_dn:
    raise w2lcore.ErrorExitClass(ldap_session,'No DN to modify.')

  if 'modrdn_newrdn' in form.inputkeys:

    modrdn_newrdn = w2lcore.input2utf(form.accept_charset,form.field['modrdn_newrdn'][0].content)
    if 'modrdn_delold' in form.inputkeys:
      modrdn_delold = form.field['modrdn_delold'][0].content=='yes'
    else:
      modrdn_delold = 0
    try:
      ldap_obj.modrdn_s(ldap_dn,modrdn_newrdn,modrdn_delold)
    except ldap.NO_SUCH_OBJECT:
      raise w2lcore.ErrorExitClass(ldap_session,'No entry <STRONG>%s</STRONG>.' % (w2lcore.utf2display(form.accept_charset,ldap_dn)))
    except ldap.INSUFFICIENT_ACCESS:
      raise w2lcore.ErrorExitClass(ldap_session,'You are not allowed to modify the DN of entry <STRONG>%s</STRONG>.' % (w2lcore.utf2display(form.accept_charset,ldap_dn)))
    except:
      exc_obj,exc_value,exc_traceback = sys.exc_info()
      raise w2lcore.ErrorExitClass(ldap_session,'Unhandled exception: %s, %s.' % (exc_obj,exc_value))

    new_dn = '%s,%s' % (modrdn_newrdn,w2lcore.ParentDN(ldap_dn))
    w2lcore.PrintHeader(outf,'Modified DN of entry.',form.accept_charset)
    w2lcore.MainMenuTable(outf,form,ldap_session,new_dn)
    outf.write('<DIV ID=MessageDiv><P>Modified DN of entry <STRONG>%s</STRONG> to <STRONG>%s</STRONG>.</P></DIV>' % (w2lcore.utf2display(form.accept_charset,ldap_dn),w2lcore.utf2display(form.accept_charset,new_dn)))
    w2lcore.PrintFooter(outf)

  else:
    form.field['modrdn_newrdn'][0].setdefault(w2lcore.utf2display(form.accept_charset,ldapbase.SplitRDN(ldap_dn)[0]))
    # Leeres Eingabeformular fr neuen RDN ausgeben
    w2lcore.PrintHeader(outf,'Modify RDN',form.accept_charset)
    w2lcore.MainMenuTable(outf,form,ldap_session)
    outf.write("""
<DIV ID=InputDiv>
<H1>Modify RDN</H1>
<FORM ACTION="%s/modrdn"
      METHOD="%s"
      ENCTYPE="application/x-www-form-urlencoded"
      ACCEPT-CHARSET="%s"
>
  <INPUT TYPE=HIDDEN NAME="ldap_dn" VALUE="%s">
  <INPUT TYPE=HIDDEN NAME="ldap_host" VALUE="%s">
  <INPUT TYPE=HIDDEN NAME="ldap_binddn" VALUE="%s">
  <INPUT TYPE=HIDDEN NAME="ldap_bindpasswd" VALUE="%s">
  <TABLE>
    <TR><TD>%s</TD><TD>%s</TD></TR>
    <TR><TD>%s</TD><TD>%s</TD></TR>
  </TABLE>
  <INPUT TYPE="submit" VALUE="Change RDN">
  <INPUT TYPE="reset" VALUE="Reset">
</FORM>
</DIV>
""" % (
      form.script_name,
      web2ldapcnf.script_method,
      form.accept_charset,
      w2lcore.utf2display(form.accept_charset,ldap_dn),
      ldap_host,
      w2lcore.utf2display(form.accept_charset,ldap_binddn),
      w2lcore.utf2display(form.accept_charset,ldap_bindpasswd),
      form.field['modrdn_newrdn'][0].text,
      form.field['modrdn_newrdn'][0].inputfield(),
      form.field['modrdn_delold'][0].text,
      form.field['modrdn_delold'][0].inputfield()
    ))
    w2lcore.PrintFooter(outf)


